var browser;
;
if (window["chrome"])
    browser = window["chrome"];
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var HObject = /** @class */ (function () {
        function HObject() {
            this.className = "HObject";
        }
        HObject.is = function (a, className) {
            return a.className == className;
        };
        return HObject;
    }());
    hinstDomElementCounter.HObject = HObject;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
///<reference path="HObject.ts"/>
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    var ReportInfo = /** @class */ (function (_super) {
        __extends(ReportInfo, _super);
        function ReportInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.Total = 0;
            _this.Mapped = {};
            _this.className = ReportInfo.ClassName;
            return _this;
        }
        ReportInfo.prototype.add = function (tagName) {
            this.Total++;
            tagName = tagName.toLowerCase();
            if (this.Mapped[tagName])
                this.Mapped[tagName]++;
            else
                this.Mapped[tagName] = 1;
        };
        ReportInfo.prototype.equals = function (a) {
            if (this == a)
                return true;
            if (this.Total != a.Total)
                return false;
            for (var x in this.Mapped) {
                if (this.Mapped[x] != a.Mapped[x])
                    return false;
            }
            return true;
        };
        ReportInfo.ClassName = "ReportInfo";
        return ReportInfo;
    }(hinstDomElementCounter.HObject));
    hinstDomElementCounter.ReportInfo = ReportInfo;
    var ReportInfoRow = /** @class */ (function () {
        function ReportInfoRow() {
        }
        ReportInfoRow.getRemainingSum = function (a, n) {
            var sum = 0;
            for (var i = n; i < a.length; ++i)
                sum += a[i].count;
            return sum;
        };
        return ReportInfoRow;
    }());
    hinstDomElementCounter.ReportInfoRow = ReportInfoRow;
    function CreateReportInfoRows(info) {
        var result = [];
        for (var key in info.Mapped) {
            var row = new ReportInfoRow();
            row.tag = key;
            row.count = info.Mapped[key];
            result.push(row);
        }
        return result;
    }
    hinstDomElementCounter.CreateReportInfoRows = CreateReportInfoRows;
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
///<reference path="../../common/browser.ts"/>
///<reference path="../../common/ReportInfo.ts"/>
var hinstDomElementCounter;
(function (hinstDomElementCounter) {
    console.log("Dom Element Counter: content staring...");
    function getElementCount(report, element) {
        report.add(element.tagName);
        var childCount = element.childElementCount;
        for (var i = 0; i < childCount; ++i)
            getElementCount(report, element.children.item(i));
    }
    var currentReport = new hinstDomElementCounter.ReportInfo();
    function update() {
        var report = new hinstDomElementCounter.ReportInfo();
        getElementCount(report, document.head);
        getElementCount(report, document.body);
        if (!currentReport.equals(report)) {
            browser.runtime.sendMessage(report);
            currentReport = report;
        }
    }
    update();
    var pageObserver = new MutationObserver(update);
    pageObserver.observe(document.body, { childList: true, subtree: true });
})(hinstDomElementCounter || (hinstDomElementCounter = {}));
//# sourceMappingURL=content.js.map